import 'package:flutter/widgets.dart';
import 'package:hub/shared/mixins/template_mixin.dart';
import 'package:hub/shared/widgets.dart';

/// [PageWidget]

abstract class PageWidget<T> extends Widget {
  const PageWidget({super.key});
}

abstract class ModelPage<T> extends ModelWidget implements PageWidget<T> {
  const ModelPage({super.key});
}

abstract class StatelessPage<T> extends StatelessWidget
    with Template
    implements PageWidget<T> {
  const StatelessPage({super.key});
}

abstract class StatefulPage<T> extends StatefulWidget implements PageWidget<T> {
  const StatefulPage({super.key});
}

abstract class PageState<T extends StatefulPage> extends State<T>
    with Template {}
